#!/usr/bin/perl

use Penguin;
use Penguin::Rights;                  # Zugriff auf Rechte-Datei
use Penguin::Frame::Code;             # Code-Frames

use Penguin::Wrapper::PGP;            # PGP-Signierung
use Penguin::Channel::TCP::Client;    # Kanal
use Penguin::Compartment;             # 'Sandkasten'

$targethost = "localhost";
$targetport = "8118";

$rightsdb = new Penguin::Rights;      # Rechte-Datei einlesen
$rightsdb->get();

$mychannel = new Penguin::Channel::TCP::Client Peer => $targethost,
                                               Port => $targetport;

                                      # Verbindung aufnehmen
$mychannel->open or die "No connection to Penguin";

$frame = $mychannel->getframe();      # Frame holen

die "Invalid frame!" if $frame eq undef;

                                      # Auspacken
($title, $signer, $wrapmethod, $code) = $frame->disassemble();

                                      # User-spezifische Rechte holen
$userrights = $rightsdb->getrights(User => $signer);

                                      # "Sandkasten" einrichten
$compartment = new Penguin::Compartment;
$compartment->initialize(Operations => $userrights);

                                      #  Snippet Ausfhren
$result = $compartment->execute(Code => $code);

if ($@) { $result = $@; }             # Befugnisse berschritten??

$mychannel->close();                  # Verbindung schlieen

print "Rckgabewert: $result\n";
